/*
Copyright (C) 2006 StrmnNrmn

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef ROMSETTINGS_H_
#define ROMSETTINGS_H_


//*****************************************************************************
// Configurable settings for a rom
//*****************************************************************************

enum ESaveType
{
	SAVE_TYPE_UNKNOWN = 0,
	SAVE_TYPE_EEP4K,
	SAVE_TYPE_EEP16K,
	SAVE_TYPE_SRAM,
	SAVE_TYPE_FLASH,

	NUM_SAVE_TYPES,
};

enum ETextureHashFrequency
{
	THF_DISABLED = 0,
	THF_EVERY_FRAME,
	THF_EVERY_2,
	THF_EVERY_5,
	THF_EVERY_10,
	THF_EVERY_30,

	NUM_THF,
};


struct RomSettings
{
	TCHAR	szGameName[50+1];		// Friendly name for this rom
	
	// Config stuff
	TCHAR		szComment[100+1];
	TCHAR		szInfo[100+1];
	ETextureHashFrequency		CheckTextureHashFrequency;
	bool		PatchesEnabled;
	bool		SpeedSyncEnabled;
	bool		DynarecEnabled;
	bool		ExpansionPakEnabled;
	ESaveType	SaveType;
	u32			dwRescanCount;
};

#include "DaedSingleton.h"

//*****************************************************************************
//
//*****************************************************************************
class	RomID;
struct	RomSettings;

//*****************************************************************************
//
//*****************************************************************************
class CRomSettingsDB : public CSingleton< CRomSettingsDB >
{
	public:
		virtual					~CRomSettingsDB() {}

		virtual bool			OpenIniFile( const char * filename ) = 0;
		virtual void			Commit() = 0;										// (STRMNNRMN - Write ini back out to disk?)

		virtual bool			GetSettings( const RomID & id, RomSettings * p_settings ) const = 0;
		virtual void			SetSettings( const RomID & id, const RomSettings & settings ) = 0;
};

#endif // ROMSETTINGS_H_
