/*
Copyright (C) 2001 StrmnNrmn

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef DEBUG_H_
#define DEBUG_H_

#include <stdarg.h>

enum DebugFlags
{
	DEBUG_PI =				 1<<1,
	DEBUG_SP =				 2<<1,
	DEBUG_DP =				 3<<1,
	DEBUG_MI =				 4<<1,
	DEBUG_SI =				 5<<1,
	DEBUG_VI =				 6<<1,
	DEBUG_AI =				 7<<1,

	DEBUG_MEMORY =			 8<<1,
	DEBUG_TLB =				 9<<1,

	DEBUG_INTR =			 10<<1,

	DEBUG_REGS =			 11<<1,

	DEBUG_MEMORY_RDRAM_REG = 13<<1,
	DEBUG_MEMORY_SP_DMEM =	 14<<1,
	DEBUG_MEMORY_SP_IMEM =	 15<<1,
	DEBUG_MEMORY_SP_REG =	 16<<1,
	DEBUG_MEMORY_MI =		 17<<1,
	DEBUG_MEMORY_VI =		 18<<1,
	DEBUG_MEMORY_AI =		 19<<1,
	DEBUG_MEMORY_RI =		 20<<1,
	DEBUG_MEMORY_SI =		 21<<1,
	DEBUG_MEMORY_PI =		 22<<1,
	DEBUG_MEMORY_PIF =		 23<<1,
	DEBUG_MEMORY_DP =		 24<<1,

	DEBUG_DYNREC =			 25<<1,
	DEBUG_OS =				 26<<1,

	DEBUG_DP_AUD =			 27<<1,
	DEBUG_DP_GFX =			 28<<1
};

#ifdef DAEDALUS_LOG

extern BOOL  g_bLog;

HRESULT		Debug_InitLogging();
void		Debug_FinishLogging();
void		Debug_Print( u32 level, const char * msg );

#define DPF( level, msg )	Debug_Print( level, msg )
     
#else		// DAEDALUS_LOGGING not defined

#define DPF( level, msg )

#endif // DAEDALUS_LOG


#endif // DEBUG_H_


