/*
Copyright (C) 2006 StrmnNrmn

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __DAEDALUS_FRAGMENTCACHE_H__
#define __DAEDALUS_FRAGMENTCACHE_H__

class	CFragment;
class	CJumpLocation;
class	CCodeBufferManager;

#include <map>
#include <vector>

class CFragmentCache
{
public:
	CFragmentCache();
	~CFragmentCache();

	CFragment *				LookupFragment( u32 address ) const;
	void					InsertFragment( CFragment * p_fragment );

	u32						GetCacheSize() const					{ return mFragmentMap.size(); }
	void					Clear();

#ifdef _DEBUG
	void					DumpStats( const char * filename ) const;
#endif

	u32						GetMemoryUsage() const					{ return mMemoryUsage; }

	CCodeBufferManager *	GetCodeBufferManager() const			{ return mpCodeBufferManager; }

private:
	typedef std::map< u32, CFragment * > FragmentMap;
	FragmentMap				mFragmentMap;
	u32						mMemoryUsage;
	u32						mInputLength;
	u32						mOutputLength;

	typedef std::vector< CJumpLocation >	JumpList;
	typedef std::map< u32, JumpList >		JumpMap;
	JumpMap					mJumpMap;

	mutable u32				mCachedFragmentAddress;
	mutable CFragment *		mpCachedFragment;

	CCodeBufferManager *	mpCodeBufferManager;

};

#endif
